#ifndef _SPRINGCARD_PCSC_H_
#define _SPRINGCARD_PCSC_H_

#ifdef UNDER_CE
#ifndef WIN32
#define WIN32
#endif
#endif


#define POWER_SUPPLY_5V     0x00
#define POWER_SUPPLY_3V     0x01
#define CARD_POWERED_MASK   0x02
#define CARD_NOT_POWERED    0x00
#define CARD_POWERED        0x02
#define CARD_INSERTED_MASK  0x04
#define CARD_NOT_INSERTED   0x00
#define CARD_INSERTED       0x04
#define T_PROTOCOL_MASK     0x08
#define T0_PROTOCOL         0x00
#define T1_PROTOCOL         0x08

#define CARD_TIMEOUT_DEFAULT  60  // 60 seconds of timeout
#define CARD_TIMEOUT_MAX    5*60  // 5 minutes of timeout max

#define Tx_STD_TYPE         0x02
#define Tx_HIS_TYPE         0x12
#define RAW_TYPE            0x01
#define ISO_MODE            0x47
#define EMV_MODE            0x45



/*
 * In pcsc_help.c
 * --------------
 */
TCHAR  *PCSC_ErrorStr(LONG err);


/*
 * Enable GBP mode
 * ---------------
 */
#define GCR_SELECT_GBP_MODE

/*
 * Select low (9600) or high (38400) baudrate
 * ------------------------------------------
 * Default is low, #define GCR_HIGH_BAUD_RATE for high (experimental)
 */
//#define GCR_HIGH_BAUD_RATE


#endif
