#ifndef __SPRINGCARD_S10_H__
#define __SPRINGCARD_S10_H__

#include "products/springcard/springcard.h"

#ifdef WIN32
  #include <windows.h>

  #ifndef SPRINGCARD_S10_LIB
    #define SPRINGCARD_S10_LIB __declspec( dllimport )
  #endif

  #ifndef UNDER_CE
    /* Under Desktop Windows we use the cdecl calling convention */
    #define SPRINGCARD_S10_API __cdecl
  #else
    /* Under Windows CE we use the stdcall calling convention */
    #define SPRINGCARD_S10_API __stdcall
  #endif

#else
  #define SPRINGCARD_S10_LIB
  #define SPRINGCARD_S10_API
#endif

#include "springcard_s10_old.h"

#ifdef __cplusplus
extern  "C"
{
#endif


SPRINGCARD_S10_LIB LONG SPRINGCARD_S10_API SCardS10ReadDataArea(SCARDHANDLE hCard, BYTE *recv_data, BYTE addr, BYTE recv_len, BYTE status[2]);
SPRINGCARD_S10_LIB LONG SPRINGCARD_S10_API SCardS10ReadProtectionArea(SCARDHANDLE hCard, BYTE recv_data[4], BYTE status[2]);
SPRINGCARD_S10_LIB LONG SPRINGCARD_S10_API SCardS10ReadSecurityArea(SCARDHANDLE hCard, BYTE recv_data[4], BYTE status[2]);

SPRINGCARD_S10_LIB LONG SPRINGCARD_S10_API SCardS10WriteDataArea(SCARDHANDLE hCard, BYTE *write_data, BYTE addr, BYTE write_len, BYTE status[2]);
SPRINGCARD_S10_LIB LONG SPRINGCARD_S10_API SCardS10WriteProtectionArea(SCARDHANDLE hCard, BYTE *write_data, BYTE addr, BYTE write_len, BYTE status[2]);
SPRINGCARD_S10_LIB LONG SPRINGCARD_S10_API SCardS10UpdateSecurityArea(SCARDHANDLE hCard, BYTE *update_data, BYTE addr, BYTE update_len, BYTE status[2]);

SPRINGCARD_S10_LIB LONG SPRINGCARD_S10_API SCardS10PSCVerification(SCARDHANDLE hCard, BYTE code3, BYTE code2, BYTE code1, BYTE status[2]);

#ifdef __cplusplus
}
#endif

#endif
