#ifndef __SPRINGCARD_S9_H__
#define __SPRINGCARD_S9_H__

#include "products/springcard/springcard.h"

#ifdef WIN32
  #include <windows.h>

  #ifndef SPRINGCARD_S9_LIB
    #define SPRINGCARD_S9_LIB __declspec( dllimport )
  #endif

  #ifndef UNDER_CE
    /* Under Desktop Windows we use the cdecl calling convention */
    #define SPRINGCARD_S9_API __cdecl
  #else
    /* Under Windows CE we use the stdcall calling convention */
    #define SPRINGCARD_S9_API __stdcall
  #endif

#else
  #define SPRINGCARD_S9_LIB
  #define SPRINGCARD_S9_API
#endif

#include "springcard_s9_old.h"

#ifdef __cplusplus
extern  "C"
{
#endif

SPRINGCARD_S9_LIB LONG SPRINGCARD_S9_API SCardS9ReadDataArea(SCARDHANDLE hCard, BYTE *recv_data, WORD addr, BYTE recv_len, BYTE status[2]);
SPRINGCARD_S9_LIB LONG SPRINGCARD_S9_API SCardS9ReadProtectionArea(SCARDHANDLE hCard, BYTE recv_data[32], WORD addr, BYTE status[2]);
SPRINGCARD_S9_LIB LONG SPRINGCARD_S9_API SCardS9ReadSecurityArea(SCARDHANDLE hCard, BYTE recv_data[3], BYTE status[2]);

SPRINGCARD_S9_LIB LONG SPRINGCARD_S9_API SCardS9WriteDataArea(SCARDHANDLE hCard, BYTE *write_data, WORD addr, BYTE write_len, BYTE status[2]);
SPRINGCARD_S9_LIB LONG SPRINGCARD_S9_API SCardS9WriteProtectionArea(SCARDHANDLE hCard, BYTE *write_data, WORD addr, BYTE write_len, BYTE status[2]);
SPRINGCARD_S9_LIB LONG SPRINGCARD_S9_API SCardS9UpdateSecurityArea(SCARDHANDLE hCard, BYTE *update_data, WORD addr, BYTE update_len, BYTE status[2]);

SPRINGCARD_S9_LIB LONG SPRINGCARD_S9_API SCardS9PSCVerification(SCARDHANDLE hCard, BYTE code2, BYTE code1, BYTE status[2]);

#ifdef __cplusplus
}
#endif

#endif
