/*
  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.

  Copyright (c) 2000-2008 SpringCard - www.springcard.com
  See COPYING for copyright and legal info
  
  serial_palmos.c
  ---------------
  High level wrappers for RS232 communication under Palm OS
  
*/

#include "springcard_i.h"

#ifdef __palmos__

#include "reader.h"
#include "pcsc_impl.h"

void    SER_EasyClose(void);
BOOL    SER_EasyOpen(void);

void CloseReader(ReaderDesc * ad_rd)
{
  SER_EasyClose();
}

int OpenReader(ReaderDesc * reader, TCHAR * device)
{
  if (!SER_EasyOpen())
    return -1;
  return 0;
}

/*
 * C-ANSI
 */
void MemCpy(void *dst, void *src, int size)
{
  int     i;
  BYTE   *pdst, *psrc;
  pdst = dst;
  psrc = src;
  for (i = 0; i < size; i++)
    pdst[i] = psrc[i];
}
void   *Malloc(int size)
{
  void   *ptr;
  ptr = MemPtrNew(size);
  return ptr;
}
void Free(void *ptr)
{
  MemPtrFree(ptr);
}

/*
 * Put reader online
 */
LONG RDR_OpenEx(S_CONTEXT_ST * context, TCHAR * port)
{
}

LONG RDR_Open(S_CONTEXT_ST * context)
{
  LONG    rc;

  if (context->enabled)
    return SCARD_S_SUCCESS;

  /* PalmOS : SpringCard-Vs is accessed without a driver */
  /* ------                                              */

  if (OpenReader(&context->desc, "") != -1)
  {
    rc = SCARD_GetFirmware(context);
    if (rc == SCARD_S_SUCCESS)
    {
      context->enabled = TRUE;
      context->start_count = 1;
    } else
    {
      CloseReader(&context->desc);
    }
    return rc;
  }
  return reader_translate_error(context);
}

#endif
