// Apdu ExchangeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "../../headers/springcard.h"

#include "Apdu Exchange.h"
#include "Apdu ExchangeDlg.h"
#include "Apdu.h"
#include "bin2c.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/* Les variables globales */
extern SCARDCONTEXT SCardContext;
extern SCARDHANDLE SCardHandle;
extern LONG SCardLastError;
extern DWORD SCardProtocol;
extern DWORD l;
extern WORD SCardReaders[102];
extern BYTE SCardAtrBuffer[32];
extern WORD SCardAtrString[65];

bool t1;
DWORD timer_again;
#define TIMER_AGAIN 5
#define TIMER_STOP  0xFFFFFFFF


// CONSTANTS
#define TIMER_ID          99

#define EDIT_PARAM_LEFT    1
#define EDIT_PARAM_TOP    48
#define EDIT_PARAM_WIDTH  16
#define EDIT_PARAM_HEIGHT 25
#define MAX_EDIT_PARAM    12


#define IDC_EDIT_PARAM_FIRST 4096

int     command_id = 0;

CEdit edit_param[MAX_EDIT_PARAM];

/////////////////////////////////////////////////////////////////////////////
// CApduExchangeDlg dialog

CApduExchangeDlg::CApduExchangeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CApduExchangeDlg::IDD, pParent)
{

	//{{AFX_DATA_INIT(CApduExchangeDlg)
	m_ins_high = _T("0");
	m_cla_high = _T("0");
	m_cla_low = _T("0");
	m_ins_low = _T("0");
	m_lc_high = _T("0");
	m_lc_low = _T("0");
	m_le_high = _T("0");
	m_le_low = _T("0");
	m_p1_high = _T("0");
	m_p1_low = _T("0");
	m_p2_high = _T("0");
	m_p2_low = _T("0");
	m_firmware = _T("");
	m_lasterror = _T("");
	m_resp = _T("");
	m_sim = FALSE;
	m_sw1 = _T("");
	m_sw2 = _T("");
	m_battery = _T("");
	m_emv = FALSE;
	m_apdu = _T("");
	m_pps = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	


	
}

void CApduExchangeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CApduExchangeDlg)
	DDX_Control(pDX, IDC_COMB_APDU, m_control_combo);
	DDX_Control(pDX, IDC_EDIT_P2_LOW, m_edit_p2_low);
	DDX_Control(pDX, IDC_EDIT_P2_HIGH, m_edit_p2_high);
	DDX_Control(pDX, IDC_EDIT_P1_LOW, m_edit_p1_low);
	DDX_Control(pDX, IDC_EDIT_P1_HIGH, m_edit_p1_high);
	DDX_Control(pDX, IDC_EDIT_LE_LOW, m_edit_le_low);
	DDX_Control(pDX, IDC_EDIT_LE_HIGH, m_edit_le_high);
	DDX_Control(pDX, IDC_EDIT_LC_LOW, m_edit_lc_low);
	DDX_Control(pDX, IDC_EDIT_LC_HIGH, m_edit_lc_high);
	DDX_Control(pDX, IDC_EDIT_INS_LOW, m_edit_ins_low);
	DDX_Control(pDX, IDC_EDIT_INS_HIGH, m_edit_ins_high);
	DDX_Control(pDX, IDC_EDIT_CLA_LOW, m_edit_cla_low);
	DDX_Control(pDX, IDC_EDIT_CLA_HIGH, m_edit_cla_high);
	DDX_Text(pDX, IDC_EDIT_INS_HIGH, m_ins_high);
	DDV_MaxChars(pDX, m_ins_high, 1);
	DDX_Text(pDX, IDC_EDIT_CLA_HIGH, m_cla_high);
	DDV_MaxChars(pDX, m_cla_high, 1);
	DDX_Text(pDX, IDC_EDIT_CLA_LOW, m_cla_low);
	DDV_MaxChars(pDX, m_cla_low, 1);
	DDX_Text(pDX, IDC_EDIT_INS_LOW, m_ins_low);
	DDV_MaxChars(pDX, m_ins_low, 1);
	DDX_Text(pDX, IDC_EDIT_LC_HIGH, m_lc_high);
	DDV_MaxChars(pDX, m_lc_high, 1);
	DDX_Text(pDX, IDC_EDIT_LC_LOW, m_lc_low);
	DDV_MaxChars(pDX, m_lc_low, 1);
	DDX_Text(pDX, IDC_EDIT_LE_HIGH, m_le_high);
	DDV_MaxChars(pDX, m_le_high, 1);
	DDX_Text(pDX, IDC_EDIT_LE_LOW, m_le_low);
	DDV_MaxChars(pDX, m_le_low, 1);
	DDX_Text(pDX, IDC_EDIT_P1_HIGH, m_p1_high);
	DDV_MaxChars(pDX, m_p1_high, 1);
	DDX_Text(pDX, IDC_EDIT_P1_LOW, m_p1_low);
	DDV_MaxChars(pDX, m_p1_low, 1);
	DDX_Text(pDX, IDC_EDIT_P2_HIGH, m_p2_high);
	DDV_MaxChars(pDX, m_p2_high, 1);
	DDX_Text(pDX, IDC_EDIT_P2_LOW, m_p2_low);
	DDV_MaxChars(pDX, m_p2_low, 1);
	DDX_Text(pDX, IDC_EDIT_FIRMWARE, m_firmware);
	DDX_Text(pDX, IDC_EDIT_LASTERROR, m_lasterror);
	DDX_Text(pDX, IDC_EDIT_RESP, m_resp);
	DDX_Check(pDX, IDC_SIM, m_sim);
	DDX_Text(pDX, IDC_EDIT_SW1, m_sw1);
	DDX_Text(pDX, IDC_EDIT_SW2, m_sw2);
	DDX_Text(pDX, IDC_EDIT_BATTERY, m_battery);
	DDX_Check(pDX, IDC_EMV, m_emv);
	DDX_CBString(pDX, IDC_COMB_APDU, m_apdu);
	DDX_Check(pDX, IDC_PPS, m_pps);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CApduExchangeDlg, CDialog)
	//{{AFX_MSG_MAP(CApduExchangeDlg)
	ON_BN_CLICKED(IDC_BUTTON2, OnButtonOff)
	ON_BN_CLICKED(IDC_BUTTON_ON, OnButtonOn)
	ON_BN_CLICKED(IDC_BUTTON_UP, OnButtonUp)
	ON_BN_CLICKED(IDC_BUTTON_DOWN, OnButtonDown)
	ON_BN_CLICKED(IDC_BUTTON_ATR, OnButtonAtr)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SIM, OnSim)
	ON_BN_CLICKED(IDC_BUTTON_EXCHANGE, OnButtonExchange)
	ON_BN_CLICKED(IDC_EMV, OnEmv)
	ON_CBN_EDITUPDATE(IDC_COMB_APDU, OnEditupdateCombApdu)
	ON_CBN_SELCHANGE(IDC_COMB_APDU, OnSelchangeCombApdu)
	ON_BN_CLICKED(IDC_BUTTON_OFF, OnButtonOff)
	ON_BN_CLICKED(IDC_PPS, OnPps)
	//}}AFX_MSG_MAP
	ON_EN_SETFOCUS(IDC_EDIT_CLA_HIGH, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_CLA_LOW, OnSetfocusEditParam)

	ON_EN_SETFOCUS(IDC_EDIT_INS_HIGH, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_INS_LOW, OnSetfocusEditParam)

	ON_EN_SETFOCUS(IDC_EDIT_LC_HIGH, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_LC_LOW, OnSetfocusEditParam)

	ON_EN_SETFOCUS(IDC_EDIT_P1_HIGH, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_P1_LOW, OnSetfocusEditParam)

	ON_EN_SETFOCUS(IDC_EDIT_P2_HIGH, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_P2_LOW, OnSetfocusEditParam)

	ON_EN_SETFOCUS(IDC_EDIT_LE_HIGH, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_LE_LOW, OnSetfocusEditParam)

	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+1, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+2, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+3, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+4, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+5, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+6, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+7, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+8, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+9, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+10, OnSetfocusEditParam)
	ON_EN_SETFOCUS(IDC_EDIT_PARAM_FIRST+11, OnSetfocusEditParam)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApduExchangeDlg message handlers

BOOL CApduExchangeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	// CLA
	Edit_ptr[0]    = &m_edit_cla_high;
	Edit_string[0] = &m_cla_high;
	Edit_ptr[1]    = &m_edit_cla_low;
	Edit_string[1] = &m_cla_low;
	// INS
	Edit_ptr[2]     = &m_edit_ins_high;
	Edit_string[2]  = &m_ins_high;
	Edit_ptr[3]     = &m_edit_ins_low;
	Edit_string[3]  = &m_ins_low;
	// P1
	Edit_ptr[4]     = &m_edit_p1_high;
	Edit_string[4]  = &m_p1_high;
	Edit_ptr[5]     = &m_edit_p1_low;
	Edit_string[5]  = &m_p1_low;
	// P2
	Edit_ptr[6]     = &m_edit_p2_high;
	Edit_string[6]  = &m_p2_high;
	Edit_ptr[7]     = &m_edit_p2_low;
	Edit_string[7]  = &m_p2_low;
	// LC
	Edit_ptr[8]     = &m_edit_lc_high;
	Edit_string[8]  = &m_lc_high;
	Edit_ptr[9]     = &m_edit_lc_low;
	Edit_string[9]  = &m_lc_low;
	// Le
	Edit_ptr[10]    = &m_edit_le_high;
	Edit_string[10] = &m_le_high;
	Edit_ptr[11]    = &m_edit_le_low;
	Edit_string[11] = &m_le_low;

  timer_again = TIMER_STOP;

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CApduExchangeDlg::OnButtonOff() 
{
	// TODO: Add your control notification handler code here
  timer_again = TIMER_STOP;
  CardClose();
  ReaderClose();
	m_battery = "";
	m_firmware = "";
	m_resp = "";	
	m_lasterror = "";
	m_sw1 ="";
	m_sw2 = "";
	m_apdu ="";
	UpdateData(FALSE);
}


void CApduExchangeDlg::OnButtonOn() 
{
	CWaitCursor wait;
	wait.Restore();

  timer_again = TIMER_STOP;

	if (ReaderOpen())
	{
	  timer_again = TIMER_AGAIN;
    SetTimer(TIMER_ID, 1000, NULL);
    m_firmware = SCardMultiStringItem(SCardContext, SCardReaders, FALSE);
	  m_lasterror = "";
	}
	else
	{
    MessageBeep(MB_ICONEXCLAMATION);
    m_firmware = "";
    m_lasterror = "SpringCard reader not found";
  }

	UpdateData(FALSE);
  timer_again = TIMER_AGAIN;
}


void CApduExchangeDlg::OnButtonUp() 
{

	// TODO: Add your control notification handler code here
	int i;

	for (i=0 ; i < EDIT_MAX ; i++)
	{
		// Edit control selected ?
		if ( (Edit_ptr[i]->GetStyle() & ES_READONLY) != ES_READONLY)
		{
			Increment(Edit_string[i]);
			if ((i == 8) || ( i==9))
			{
				UpdateParameter();
			}	
		}
	}

	// Parameter ?
	for (i=0 ; i < MAX_EDIT_PARAM ; i++)
	{
		if ( (edit_param[i].GetStyle() & ES_READONLY) != ES_READONLY)
		{			
			Increment_param(&edit_param[i]);
		}
	}
	// Upadate date on screen
	ApduUpdate();
	UpdateData(FALSE);
	
	
}

void CApduExchangeDlg::OnButtonDown() 
{
	// TODO: Add your control notification handler code here
	int i;

	for (i=0 ; i < EDIT_MAX ; i++)
	{
		if ( (Edit_ptr[i]->GetStyle() & ES_READONLY) != ES_READONLY)
		{			
			Decrement(Edit_string[i]);
			if ((i == 8) || ( i==9))
			{
				UpdateParameter();
			}	
		}
	}
	// Parameter ?
	for (i=0 ; i < MAX_EDIT_PARAM ; i++)
	{
		if ( (edit_param[i].GetStyle() & ES_READONLY) != ES_READONLY)
		{			
			Decrement_param(&edit_param[i]);
		}
	}
	// Upadate date on screen
	ApduUpdate();
	UpdateData(FALSE);
	
}


void CApduExchangeDlg::OnButtonAtr() 
{
  CWaitCursor wait;
	wait.Restore();

  timer_again = TIMER_STOP;

	if (SCardHandle != 0)
		CardClose();

	if (CardOpen(m_sim, m_emv, m_pps))
  {	
  	m_lasterror = "";
    if (SCardProtocol == SCARD_PROTOCOL_T0)
    {
	    m_resp = "ATR (T=0) : " + CString(SCardAtrString);
    }	else
		if (SCardProtocol == SCARD_PROTOCOL_T1)
    {
		  m_resp = "ATR (T=1) : " + CString(SCardAtrString);
    } else
    {
			m_resp = "ATR (T=?) : " + CString(SCardAtrString);
    }
	}	else
  {
    MessageBeep(MB_ICONEXCLAMATION);
	  m_resp = "ATR : ?";
	  m_lasterror = SCardErrorToString(SCardContext, SCardLastError);
	}

	UpdateData(FALSE);
  timer_again = TIMER_AGAIN;	
}

void CApduExchangeDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	SYSTEM_POWER_STATUS_EX  status;
	int percent;
	char tmp[6];

  if ((timer_again > 0) && (timer_again != TIMER_STOP))
  {
    timer_again--;    
  } else
  {
	  /* "Keep alive" on serial port to prevent automatic power-off by the OS */
	  if (!CardPresent())
		  OnButtonOff();

    /* Get power */
	  if (GetSystemPowerStatusEx(&status, true))
	  {
	    percent = status.BatteryLifePercent;
	    _itoa(percent,tmp,10);
	    m_battery = CString(tmp) + _T("%");
	    UpdateData(FALSE);
	  }

    /* Go on later */
	  timer_again = TIMER_AGAIN;
  }

	CDialog::OnTimer(nIDEvent);
}

void CApduExchangeDlg::OnSim() 
{
	// TODO: Add your control notification handler code here
	m_sim = !m_sim;	
	OnButtonOff();
	UpdateData(FALSE);
}

void CApduExchangeDlg::Increment(CString *edit_control)
{
	unsigned char value;
	char string_value;

	string_value = (char)*edit_control[0];
	value = c2bin(&string_value, 1);	
	if (value >=15)
		value = 0;
	else
		value = value +1 ;
	string_value = bin2hex(value);
	*edit_control = string_value;
}

void CApduExchangeDlg::Decrement(CString *edit_control)
{
	unsigned char value;
	char string_value;

	string_value = (char)*edit_control[0];
	value = c2bin(&string_value, 1);	
	if (value <= 0)
		value = 15;
	else
		value = value -1;
	string_value = bin2hex(value);
	*edit_control = string_value;

}

void CApduExchangeDlg::OnButtonExchange() 
{
	TCHAR buffer_resp[MAX_BUFFER_SIZE];
	DWORD send_len;
	int nIndex = 0;
  CWaitCursor wait;
	BYTE sw1,sw2;

	/* Cursor on */
	wait.Restore();

  timer_again = TIMER_STOP;

	ApduUpdate();
	/* Clear all */
	m_sw1 = "";
	m_sw2 = "";
	m_resp = "";
	m_lasterror = "";

	send_len = m_apdu.GetLength();
	/* Display apdu command */
	UpdateData(FALSE);

	/* Log storage */
	if (m_control_combo.FindStringExact(nIndex, m_apdu) == LB_ERR) 
		m_control_combo.AddString(m_apdu);	
	
	/* Apdu Command Exchange */
	if (SpringCard_ApduExchange(m_apdu, send_len , buffer_resp , MAX_BUFFER_SIZE))
	{
		m_resp = CString(buffer_resp);
		m_sw1 = m_resp.Mid(m_resp.GetLength()-4,2);
		m_sw2 = m_resp.Mid(m_resp.GetLength()-2,2);
		SCardHexToByte(SCardContext,&sw1,(LPCTSTR )m_sw1);
		SCardHexToByte(SCardContext,&sw2,(LPCTSTR )m_sw2);
		m_lasterror = SCardISOErrorToString(SCardContext, sw1,sw2);
	}
	else
	{
		MessageBeep(MB_ICONEXCLAMATION);
		m_sw1 = "";
		m_sw2 = "";
		m_resp = CString(buffer_resp);
		m_lasterror = SCardErrorToString(SCardContext, SCardLastError);
	}
	UpdateData(FALSE);

  timer_again = TIMER_AGAIN;
}

void CApduExchangeDlg::UpdateParameter()
{
	unsigned char value;
	char string_value_high,string_value_low;
	int i ,left, top, rigth, bottom, delta =0 , ctrl_id;

	left   = EDIT_PARAM_LEFT;
	top    = EDIT_PARAM_TOP ;
	rigth  = EDIT_PARAM_LEFT + EDIT_PARAM_WIDTH;
	bottom = EDIT_PARAM_TOP + EDIT_PARAM_HEIGHT;
	
	for (i=0 ; i < MAX_EDIT_PARAM ; i++)
	{
		edit_param[i].DestroyWindow();
	}
	string_value_high = (char)*m_lc_high;
	string_value_low  = (char)*m_lc_low;

	value = c2bin(&string_value_high, 1)*10 + c2bin(&string_value_low, 1);
	if (value > MAX_EDIT_PARAM/2 ) value = MAX_EDIT_PARAM/2;
	for (i=0 ; i < value ; i++)
	{
		// Create Edit Control - High
		ctrl_id = IDC_EDIT_PARAM_FIRST + i*2 ;		
		edit_param[i*2].Create(ES_MULTILINE | WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_BORDER,
		CRect(left + delta ,top ,rigth + delta,bottom), this, ctrl_id );		
		edit_param[i*2].SetReadOnly(TRUE);
		// Init to zero
		SetDlgItemText(ctrl_id,_T("0"));
		//
		// Create Edit Control - Low
		delta = delta + EDIT_PARAM_WIDTH  +1;
		ctrl_id = IDC_EDIT_PARAM_FIRST + i*2 +1;		
		edit_param[(i*2)+1].Create(ES_MULTILINE | WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_BORDER,
		CRect(left + delta ,top ,rigth + delta,bottom), this, ctrl_id);		
		edit_param[(i*2)+1].SetReadOnly(TRUE);
		// Init to zero
		SetDlgItemText(ctrl_id ,_T("0"));
		delta = delta + EDIT_PARAM_WIDTH +2;
	}

}



void CApduExchangeDlg::OnSetfocusEditParam()
{
	int i;
	CEdit *ptr_Edit;

	// Mask all edit
	for (i=0 ; i < EDIT_MAX ; i++)
		Edit_ptr[i]->SetReadOnly(TRUE);	
	// Mask all edit_param
	for (i=0 ; i < MAX_EDIT_PARAM ; i++)
		edit_param[i].SetReadOnly(TRUE);

	// Edit Selected 
	ptr_Edit = (CEdit *)GetFocus();
	ptr_Edit->SetReadOnly(FALSE);

}

void CApduExchangeDlg::Decrement_param(CEdit * ptr_edit_param)
{
	int ctrl_id;
	CString string_value;

	ctrl_id = ptr_edit_param->GetDlgCtrlID();
	GetDlgItemText(ctrl_id,string_value);
	Decrement(&string_value);
	SetDlgItemText(ctrl_id,string_value);
	UpdateData(FALSE);
}

void CApduExchangeDlg::Increment_param(CEdit *ptr_edit_param)
{
	int ctrl_id;
	CString string_value;

	ctrl_id = ptr_edit_param->GetDlgCtrlID();
	GetDlgItemText(ctrl_id,string_value);
	Increment(&string_value);
	SetDlgItemText(ctrl_id,string_value);
	UpdateData(FALSE);
}

void CApduExchangeDlg::ApduUpdate()
{	
	CString string_value_high,string_value_low;
	int i,value;

	m_apdu =  m_cla_high + m_cla_low + m_ins_high + m_ins_low + m_p1_high + m_p1_low + m_p2_high + m_p2_low;
	if ((m_lc_high == "0") && (m_lc_low == "0"))
	{
		// Lc = 0
		if ((m_le_high == "0") && (m_le_low == "0"))
		{
			// Nothing
		} else
		{
		    m_apdu = m_apdu + m_le_high + m_le_low;
		}
	}
	else
	{
		// Lc != 0
		if ((m_le_high == "0") && (m_le_low == "0"))
		{
		    m_apdu = m_apdu + m_lc_high + m_lc_low;
			string_value_high = (char)*m_lc_high;
			string_value_low  = (char)*m_lc_low;

			value = c2bin((char *)&string_value_high, 1)*10 + c2bin((char *)&string_value_low, 1);
			if ( value < MAX_EDIT_PARAM/2 ) value = MAX_EDIT_PARAM/2;
			for (i=0 ; i< value;i++)
			{
				GetDlgItemText(IDC_EDIT_PARAM_FIRST + (i*2),string_value_high);
				GetDlgItemText(IDC_EDIT_PARAM_FIRST+1 + (i*2),string_value_low);
				m_apdu = m_apdu + string_value_high + string_value_low;
			}
		} else
		{
			// Error
			/*SCardMessageBox(_T("If 'lc' != Zero => 'Le' must egal to Zero"));*/
		}
	}
	/* History Command */

	UpdateData(FALSE);
}


BOOL CApduExchangeDlg::PreTranslateMessage(MSG* pMsg) 
{
	CString string_value;

	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message==WM_KEYUP /*&& pMsg->wParam==VK_KEYUP*/)
	{ 
		if (pMsg->wParam== VK_UP)
		{
			OnButtonUp();
		}
		if (pMsg->wParam== VK_DOWN)
		{
			OnButtonDown();
		}
		if (pMsg->wParam== VK_RIGHT)
		{
			pMsg->message = WM_KEYDOWN; 
			pMsg->wParam=VK_TAB;
		}
/*		if (pMsg->wParam== VK_LEFT)
		{
			pMsg->message = WM_KEYDOWN; 
			pMsg->wParam=VK_SHIFT;		
		}
*/		
		
	
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CApduExchangeDlg::OnEmv() 
{
	// TODO: Add your control notification handler code here
	m_emv = !m_emv;	
	OnButtonOff();
	UpdateData(FALSE);
}


void CApduExchangeDlg::ParameterUpdate()
{
	int i,len,ctrl_id;

	m_cla_high = m_apdu[0];
	m_cla_low  = m_apdu[1];
	m_ins_high = m_apdu[2];
	m_ins_low  = m_apdu[3];
	m_p1_high  = m_apdu[4];
	m_p1_low   = m_apdu[5];
	m_p2_high  = m_apdu[6];
	m_p2_low   = m_apdu[7];

	len = m_apdu.GetLength();
	if ( len == 10)
	{
		m_lc_high  = "0";
		m_lc_low   = "0";	
		m_le_high  = m_apdu[8];
		m_le_low   = m_apdu[9];	
		UpdateParameter();			
	}
	else
	{
		m_lc_high  = m_apdu[8];
		m_lc_low   = m_apdu[9];	
		UpdateParameter();
		for (i=0 ; i < (len -10)/2 ; i++)
		{
			ctrl_id = edit_param[i*2].GetDlgCtrlID();
			SetDlgItemText(ctrl_id,CString(m_apdu[(i*2) + 10]));
			ctrl_id = edit_param[(i*2)+1].GetDlgCtrlID();
			SetDlgItemText(ctrl_id,CString(m_apdu[(i*2) + 11]));
		}
		m_le_high  = "0";
		m_le_low   = "0";
	}
	
}

void CApduExchangeDlg::OnEditupdateCombApdu() 
{
	// TODO: Add your control notification handler code here
	ParameterUpdate();
	UpdateData(FALSE);
}

void CApduExchangeDlg::OnSelchangeCombApdu() 
{
	// TODO: Add your control notification handler code here
	m_control_combo.GetLBText(m_control_combo.GetCurSel(),m_apdu);
	ParameterUpdate();
	UpdateData(FALSE);
}

void CApduExchangeDlg::OnPps() 
{
	m_pps = !m_pps;	
	OnButtonOff();
	UpdateData(FALSE);
}
