/*
  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.

  Copyright (c) 2000-2002 Pro-Active SARL
  See COPYING for copyright and legal info
  
  sctypes.h
  ---------
  Prototypes and defines for portability between Windows CE and Palm OS 
*/

#ifndef _SPRINGCARD_TYPES_H
#define _SPRINGCARD_TYPES_H

/* Workaround for CodeWarrior that doesn't define the target system ! */
#ifdef __MC68K__
  #define __palmos__
#endif


/* Translating target to size */
/* -------------------------- */
#ifdef __palmos__
  #define __IRLIB_H__
  typedef unsigned char	 BYTE;
  typedef signed char    SBYTE;
  typedef unsigned char	 BOOL;
  typedef signed short   SWORD;
  typedef signed long    SDWORD;
  typedef unsigned short WORD;
  typedef unsigned long  DWORD;
  typedef signed long    LONG;
  typedef const void *   LPCVOID;
  typedef void *         LPVOID;  
  typedef const char *   LPCTSTR;
  typedef char *         LPTSTR;
  typedef BYTE *         LPBYTE; 
  typedef DWORD *        LPDWORD;
  typedef LONG *         LPLONG;  
  #define IN
  #define OUT
  #define FALSE 0
  #define TRUE  1
  #define _T(x) x
  #define TCHAR char
  #define strlen StrLen
  #define memset(a,b,c) MemSet(a,c,b)
  #define memcpy(a,b,c) MemCpy(a,b,c)
  #define malloc(a) Malloc(a)
  #define free(a) Free(a)
  #define _tcscpy(a,b) StrCopy(a,b)
  #define _tcsncpy(a,b,c) StrNCopy(a,b,c)
  #define _tcslen(a) StrLen(a)
  #define _tcsclen(a) StrLen(a)
  #define _stprintf StrPrintF
  #define _tcsncat(a,b,c) StrNCat(a,b,c)
  #define _tcscat(a,b) StrCat(a,b)
  #define strcat(a,b) StrCat(a,b)
  #define strncmp(a,b,c) StrNCompare(a,b,c)
  #define strcpy(a,b) StrCopy(a,b)
  void MemCpy(void *dst, void *src, int size);
  void *Malloc(int size);
  void Free(void *ptr);
  #define TYPE_HANDLE WORD
  #define WRITE_COM(a,b,c)	SER_Write((BYTE *)b,c)
  #define READ_COM(a,b,c)   SER_Read((BYTE *)b,c)
  #define LIB_STATIC     static
#endif

#ifdef UNDER_CE
  #ifndef WIN32
    #define WIN32
  #endif
#endif

#ifdef WIN32
  #include <windows.h>
  #include <tchar.h>
  #include <stdio.h>
  typedef unsigned char  BYTE;
  typedef signed char    SBYTE;
  typedef signed short   SWORD;
  typedef signed long    SDWORD;
  typedef unsigned char  BITS;
  #define TYPE_HANDLE HANDLE
  #define WRITE_COM	WriteCom
  #define READ_COM	ReadCom
  #define LIB_STATIC  
#endif

#ifdef __linux__
  #include <unistd.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <time.h>
  #ifndef __LIB_TYPES_H__
    typedef unsigned char	 BYTE;
    typedef signed char    SBYTE;
    typedef unsigned char	 BOOL;
    typedef signed short   SWORD;
    typedef signed long    SDWORD;
    typedef unsigned short WORD;
    typedef unsigned long  DWORD;
    typedef signed long    LONG;
    #define FALSE 0
    #define TRUE  1
  #endif
  typedef const void *   LPCVOID;
  typedef void *         LPVOID;  
  typedef const char *   LPCTSTR;
  typedef char *         LPTSTR;
  typedef BYTE *         LPBYTE; 
  typedef DWORD *        LPDWORD;
  typedef LONG *         LPLONG;
  typedef int            HANDLE;
  #define IN
  #define OUT
  #define _T(x) x
  #define TCHAR char
  #define _tcscpy(a,b) strcpy(a,b)
  #define _tcsncpy(a,b,c) strncpy(a,b,c)
  #define _tcslen(a) strlen(a)
  #define _tcsclen(a) strlen(a)
  #define _stprintf sprintf
  #define _tcsncat(a,b,c) strncat(a,b,c)
  #define _tcscat(a,b) strcat(a,b)
  #define _stscanf sscanf
  #define TYPE_HANDLE int
  #define WRITE_COM	WriteCom
  #define READ_COM	ReadCom
  #define LIB_STATIC  
#endif

#endif
